#!BPY
"""
Name: 'Sculpt Mesh'
Blender: 245.14
Group: 'AddMesh'
Tooltip: 'Add a plane/torus/cylinder or sphere with square tiled UV map and multires'
"""
import Blender
from import_sculptie import new_sculptie

def main():
	block = []
	sculpt_type = Blender.Draw.Create ( 1 )
	faces_x = Blender.Draw.Create( 8 )
	faces_y = Blender.Draw.Create( 8 )
	multires_levels = Blender.Draw.Create( 2 )
	block.append (( "Mesh Type: ", sculpt_type, 1, 4 ))
	block.append (( "      1 Sphere  2 Torus" ))
	block.append (( "      3 Plane   4 Cylinder" ))
	block.append (( "" ))
	block.append (( "X Faces", faces_x, 1, 256 ))
	block.append (( "Y Faces", faces_y, 1, 256))
	block.append (( "Multires Levels", multires_levels, 0, 255 ))
	if Blender.Draw.PupBlock( "Sculpt Mesh Options", block ):
		in_editmode = Blender.Window.EditMode()
		# MUST leave edit mode before changing an active mesh:
		if in_editmode:
			Blender.Window.EditMode(0)
		ob = new_sculptie( int(str(sculpt_type)), int(str(faces_x)), int(str(faces_y)), int(str(multires_levels)) )
		if in_editmode:
			Blender.Window.EditMode(1)

main()
